<?php
/**
 * Plugin Taula Guia: EAPC
 *
 * Syntax: ~~TAULA GUIA~~ - Convert this page to "Taula Guia" mode
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Eduard Diaz <edudiaz@scopia.es>
 */

if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../').'/');
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
 
class syntax_plugin_taulaguia extends DokuWiki_Syntax_Plugin {
    
    function getType(){
        return 'substition';
    }
    
    function getPType(){
        return 'normal';
    }
    
    function getSort(){
        return 30;
    }
    
    function connectTo($mode) {
        $this->Lexer->addSpecialPattern('~~TAULA GUIA~~', $mode, 'plugin_taulaguia');
        $this->Lexer->addSpecialPattern('~~TAULA GUIA [^\r\n]*?~~\n', $mode, 'plugin_taulaguia');
    }
    
    
    function handle($match, $state, $pos, &$handler){
        switch ($state) {
          case DOKU_LEXER_SPECIAL :
            if($match!='~~TAULA GUIA~~'){
                $tguia = strtolower(trim(substr($match,12,-3)));
                if (in_array($tguia, array("table", "none")) )
                    return array($tguia);
            }else{
                return array("tree");
            }
            
            break;
        }
        return array();
    }
    
    
    function render($format, &$renderer, $data) {
        global $ID;
        if($format == 'xhtml'){
            if($data){ 
                $this->set_scopia_metaFN($data[0]);
                $renderer->doc .= '<a name="'.$data[0].'" class="tblguia-metadata"> </a>';
            }
            return true;
        }else if ($format == 'odt'){
            return true;
        }
        return false;
    }

    function set_scopia_metaFN($tbltype){
        global $ID;
        
        if( !in_array($tbltype, array("tree", "table", "none")) ) 
            return false;
            
        $file = metaFN($ID, '.scopia');
        $data = array();
        if (@file_exists($file)) {
            $data = unserialize(io_readFile($file, false));
        }
        if(empty($data['type']) || $data['type'] != $tbltype){
            $data['id']=$ID;
            $data['type'] = $tbltype;
            io_saveFile($file, serialize($data));
            return true;
        }
        return false;
    }
    
}

?>
